org.apache.poi.sl.usermodel

## Interface TextParagraph<S extends Shape<S,P>,P extends TextParagraph<S,P,T>,T extends TextRun>

- All Superinterfaces:
    java.lang.Iterable<T>
  All Known Implementing Classes:
    HSLFTextParagraph, XSLFTextParagraph

      public interface TextParagraph<S extends Shape<S,P>,P extends TextParagraph<S,P,T>,T extends TextRun>
      extends java.lang.Iterable<T>

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static interface` | `TextParagraph.BulletStyle`
    `static class` | `TextParagraph.FontAlign`
    `static class` | `TextParagraph.TextAlign` Specifies a list of text alignment types

  - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addTabStops(double positionInPoints, TabStop.TabStopType tabStopType)` Set the `TabStop` collection
    `void` | `clearTabStops()` Removes the tabstops of this paragraphs.
    `TextParagraph.BulletStyle` | `getBulletStyle()`
    `java.lang.String` | `getDefaultFontFamily()`
    `java.lang.Double` | `getDefaultFontSize()`
    `java.lang.Double` | `getDefaultTabSize()`
    `TextParagraph.FontAlign` | `getFontAlign()` Returns the font alignment that is applied to the paragraph.
    `java.lang.Double` | `getIndent()`
    `int` | `getIndentLevel()`
    `java.lang.Double` | `getLeftMargin()`
    `java.lang.Double` | `getLineSpacing()` Returns the vertical line spacing that is to be used within a paragraph.
    `TextShape<S,P>` | `getParentShape()`
    `java.lang.Double` | `getRightMargin()` Specifies the right margin of the paragraph.
    `java.lang.Double` | `getSpaceAfter()` The amount of vertical white space after the paragraph This may be specified in two different ways, percentage spacing and font point spacing:
    `java.lang.Double` | `getSpaceBefore()` The amount of vertical white space before the paragraph This may be specified in two different ways, percentage spacing and font point spacing:
    `java.util.List<? extends TabStop>` | `getTabStops()` Get the `TabStops` - the list can't be and it's entries shouldn't be modified.
    `TextParagraph.TextAlign` | `getTextAlign()` Returns the alignment that is applied to the paragraph.
    `java.util.List<T>` | `getTextRuns()` Fetch the text runs that are contained within this block of text
    `boolean` | `isHeaderOrFooter()` Convenience method to determine if this text paragraph is part of the slide header or footer
    `void` | `setBulletStyle(java.lang.Object... styles)` Sets the bullet styles.
    `void` | `setIndent(java.lang.Double indent)` Specifies the indent size that will be applied to the first line of text in the paragraph.
    `void` | `setIndentLevel(int level)` Specifies the particular level text properties that this paragraph will follow.
    `void` | `setLeftMargin(java.lang.Double leftMargin)` Specifies the left margin of the paragraph.
    `void` | `setLineSpacing(java.lang.Double lineSpacing)` This element specifies the vertical line spacing that is to be used within a paragraph.
    `void` | `setRightMargin(java.lang.Double rightMargin)`
    `void` | `setSpaceAfter(java.lang.Double spaceAfter)` Set the amount of vertical white space that will be present after the paragraph.
    `void` | `setSpaceBefore(java.lang.Double spaceBefore)` Set the amount of vertical white space that will be present before the paragraph.
    `void` | `setTextAlign(TextParagraph.TextAlign align)` Specifies the alignment that is to be applied to the paragraph.

    - ### Methods inherited from interface java.lang.Iterable

      `forEach, iterator, spliterator`

- - ### Method Detail

    - #### getSpaceBefore

          java.lang.Double getSpaceBefore()

      The amount of vertical white space before the paragraph This may be specified in two different ways, percentage spacing and font point spacing:

      If spaceBefore >= 0, then space is a percentage of normal line height. If spaceBefore < 0, the absolute value in points

      Returns:
        the vertical white space before the paragraph, or null if unset

    - #### setSpaceBefore

          void setSpaceBefore(java.lang.Double spaceBefore)

      Set the amount of vertical white space that will be present before the paragraph. This space is specified in either percentage or points:

      If spaceBefore >= 0, then space is a percentage of normal line height. If spaceBefore < 0, the absolute value of linespacing is the spacing in points

      Examples:

                // The paragraph will be formatted to have a spacing before the paragraph text.
                // The spacing will be 200% of the size of the largest text on each line
                paragraph.setSpaceBefore(200);

                // The spacing will be a size of 48 points
                paragraph.setSpaceBefore(-48.0);

      Parameters:
        `spaceBefore` - the vertical white space before the paragraph, null to unset

    - #### getSpaceAfter

          java.lang.Double getSpaceAfter()

      The amount of vertical white space after the paragraph This may be specified in two different ways, percentage spacing and font point spacing:

      If spaceBefore >= 0, then space is a percentage of normal line height. If spaceBefore < 0, the absolute value of linespacing is the spacing in points

      Returns:
        the vertical white space after the paragraph or null, if unset

    - #### setSpaceAfter

          void setSpaceAfter(java.lang.Double spaceAfter)

      Set the amount of vertical white space that will be present after the paragraph. This space is specified in either percentage or points:

      If spaceAfter >= 0, then space is a percentage of normal line height. If spaceAfter < 0, the absolute value of linespacing is the spacing in points

      Examples:

                // The paragraph will be formatted to have a spacing after the paragraph text.
                // The spacing will be 200% of the size of the largest text on each line
                paragraph.setSpaceAfter(200);

                // The spacing will be a size of 48 points
                paragraph.setSpaceAfter(-48.0);

      Parameters:
        `spaceAfter` - the vertical white space after the paragraph, null to unset

    - #### getLeftMargin

          java.lang.Double getLeftMargin()

      Returns:
        the left margin (in points) of the paragraph or null, if unset

    - #### setLeftMargin

          void setLeftMargin(java.lang.Double leftMargin)

      Specifies the left margin of the paragraph. This is specified in addition to the text body inset and applies only to this text paragraph. That is the text body Inset and the LeftMargin attributes are additive with respect to the text position.
      Parameters:
        `leftMargin` - the left margin (in points) or null to unset

    - #### getRightMargin

          java.lang.Double getRightMargin()

      Specifies the right margin of the paragraph. This is specified in addition to the text body inset and applies only to this text paragraph. That is the text body Inset and the RightMargin attributes are additive with respect to the text position. The right margin is not support and therefore ignored by the HSLF implementation.
      Returns:
        the right margin (in points) of the paragraph or null, if unset

    - #### setRightMargin

          void setRightMargin(java.lang.Double rightMargin)

      Parameters:
        `rightMargin` - the right margin (in points) of the paragraph

    - #### getIndent

          java.lang.Double getIndent()

      Returns:
        the indent (in points) applied to the first line of text in the paragraph. or null, if unset

    - #### setIndent

          void setIndent(java.lang.Double indent)

      Specifies the indent size that will be applied to the first line of text in the paragraph.
      Parameters:
        `indent` - the indent (in points) applied to the first line of text in the paragraph

    - #### getIndentLevel

          int getIndentLevel()

      Returns:
        the text level of this paragraph (0-based). Default is 0.

    - #### setIndentLevel

          void setIndentLevel(int level)

      Specifies the particular level text properties that this paragraph will follow. The value for this attribute formats the text according to the corresponding level paragraph properties defined in the SlideMaster.
      Parameters:
        `level` - the level (0 ... 4)

    - #### getLineSpacing

          java.lang.Double getLineSpacing()

      Returns the vertical line spacing that is to be used within a paragraph. This may be specified in two different ways, percentage spacing and font point spacing:

      If linespacing >= 0, then linespacing is a percentage of normal line height. If linespacing < 0, the absolute value of linespacing is the spacing in points

      Returns:
        the vertical line spacing or null, if unset

    - #### setLineSpacing

          void setLineSpacing(java.lang.Double lineSpacing)

      This element specifies the vertical line spacing that is to be used within a paragraph. This may be specified in two different ways, percentage spacing and font point spacing:

      If linespacing >= 0, then linespacing is a percentage of normal line height If linespacing < 0, the absolute value of linespacing is the spacing in points

      Examples:

                // spacing will be 120% of the size of the largest text on each line
                paragraph.setLineSpacing(120);

                // spacing will be 200% of the size of the largest text on each line
                paragraph.setLineSpacing(200);

                // spacing will be 48 points
                paragraph.setLineSpacing(-48.0);

      Parameters:
        `lineSpacing` - the vertical line spacing

    - #### getDefaultFontFamily

          java.lang.String getDefaultFontFamily()

    - #### getDefaultFontSize

          java.lang.Double getDefaultFontSize()

      Returns:
        the default font size, in case its not set in the textrun or null, if unset

    - #### getTextAlign

          TextParagraph.TextAlign getTextAlign()

      Returns the alignment that is applied to the paragraph. If this attribute is omitted, then null is returned. User code can imply the value `TextParagraph.TextAlign.LEFT` then.
      Returns:
        alignment that is applied to the paragraph

    - #### setTextAlign

          void setTextAlign(TextParagraph.TextAlign align)

      Specifies the alignment that is to be applied to the paragraph. Possible values for this include left, right, centered, justified and distributed, see `TextParagraph.TextAlign`.
      Parameters:
        `align` - text align

    - #### getFontAlign

          TextParagraph.FontAlign getFontAlign()

      Returns the font alignment that is applied to the paragraph. If this attribute is omitted, then null is return, user code can imply the a value of `TextParagraph.FontAlign.AUTO`
      Returns:
        alignment that is applied to the paragraph

    - #### getBulletStyle

          TextParagraph.BulletStyle getBulletStyle()

      Returns:
        the bullet style of the paragraph, if `null` then no bullets are used

    - #### setBulletStyle

          void setBulletStyle(java.lang.Object... styles)

      Sets the bullet styles. If no styles are given, the bullets are omitted. Possible attributes are integer/double (bullet size), Color (bullet color), character (bullet character), string (bullet font), AutoNumberingScheme
      Parameters:
        `styles` -

    - #### getDefaultTabSize

          java.lang.Double getDefaultTabSize()

      Returns:
        the default size for a tab character within this paragraph in points, null if unset

    - #### getParentShape

          TextShape<S,P> getParentShape()

    - #### getTextRuns

          java.util.List<T> getTextRuns()

      Fetch the text runs that are contained within this block of text

    - #### isHeaderOrFooter

          boolean isHeaderOrFooter()

      Convenience method to determine if this text paragraph is part of the slide header or footer
      Returns:
        true if this paragraph is part of a header or footer placeholder
      Since:
        POI 3.15-beta2

    - #### getTabStops

          java.util.List<? extends TabStop> getTabStops()

      Get the `TabStops` - the list can't be and it's entries shouldn't be modified. Opposed to other properties, this method is not cascading to the master sheet, if the property is not defined on the normal slide level, i.e. the tabstops on different levels aren't merged.
      Returns:
        the tabstop collection or `null` if no tabstops are defined
      Since:
        POI 4.0.0

    - #### addTabStops

          void addTabStops(double positionInPoints,
                           TabStop.TabStopType tabStopType)

      Set the `TabStop` collection
      Parameters:
        `tabStops` - the `TabStop` collection
      Since:
        POI 4.0.0

    - #### clearTabStops

          void clearTabStops()

      Removes the tabstops of this paragraphs. This doesn't affect inherited tabstops, e.g. inherited by the slide master
      Since:
        POI 4.0.0

Copyright 2020 The Apache Software Foundation or its licensors, as applicable.